<?php

/**
 * Author: Tommy
 * Date: 21 Sep, 2022
 * User model
 */

class User
{
  public $id;
  public $username;
  public $email;
  public $password;
  public $birthdate;
  public $phone_number;
  public $url;

  function __construct($id, $username, $email, $password, $birthdate, $phone_number, $url)
  {
    $this->id           = $id;
    $this->username     = $username;
    $this->email        = $email;
    $this->password     = $password;
    $this->birthdate    = $birthdate;
    $this->phone_number = $phone_number;
    $this->url          = $url;
  }

  /**
   * Get all users
   */
  static function getAll()
  {
    
    $users = [];    
    $db = GbgDB::getInstance();    
    $request = $db->query('SELECT * FROM users');   
    foreach ($request->fetchAll() as $item) {      
      $users[] = new User($item['id'], $item['username'], $item['email'], $item['password'], $item['birthdate'], $item['phone_number'], $item['url']);      
    }    
    $request->closeCursor();
    return $users;
  }

  /**
   * Find user
   */
  static function find($id)
  {    
    $db = GbgDB::getInstance();
    $request = $db->prepare('SELECT * FROM users WHERE id = :id');
    $request->execute(array('id' => $id));
    $item = $request->fetch();   
    if (isset($item['id'])) {
      return new User($item['id'], $item['username'], $item['email'], $item['password'], $item['birthdate'], $item['phone_number'], $item['url']);    
    }
    $request->closeCursor();
    return null;
  }

  /**
   * Create a user
   */
  static function create($username, $email, $password, $birthdate, $phone_number, $url) 
  {
    $db = GbgDB::getInstance();
    $request = $db->prepare("INSERT INTO users (username, email, password, birthdate, phone_number, url) 
      VALUES (:username, :email, :password, :birthdate, :phone_number, :url)");
    
    $request->bindParam(':username', $username);
    $request->bindParam(':email', $email);
    $request->bindParam(':password', $password);

    $request->bindParam(':birthdate', $birthdate);
    $request->bindParam(':phone_number', $phone_number);
    $request->bindParam(':url', $url);
    
    $request->execute();
    $request->closeCursor();
  }

  /**
   * Delete user
   */
  static function delete($id)
  {    
    $db = GbgDB::getInstance();
    $request = $db->prepare('DELETE FROM users WHERE id = :id');
    $request->execute(array('id' => $id));
    $request->closeCursor();
  }


}